/***************************************************************************
 *   Copyright (C) 2009 by Eugene Korotkov   *
 *   cyberozz@yandex.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef dev_h
#define dev_h

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdbool.h>

typedef struct {
  int fd;
  char *name;
  unsigned int speed;
} t_device;


bool close_dev(t_device *dev);
int open_dev(t_device *dev, unsigned long sleeptime);
bool write_dev(t_device*dev, const char *string);
char get_onebyte(t_device *dev, unsigned int sleeptime);
int reset_dev(t_device *dev, unsigned int sleeptime);
char *get_string(t_device *dev, char *str, 
	unsigned int maxsize, unsigned int sleeptime);
	
int lock_dev(char *filename);
int unlock_dev(char *filename);
bool is_devlocked(char *filename);

extern int theVerbosity;	// actually defined in main.cpp

#define DEBUG(format, ...)	{if (theVerbosity>0) fprintf(stderr, "t=%03ld: " format, time(NULL)%1000, ## __VA_ARGS__);}

#endif //dev_h
